/*
 * Dziaajcy printf dla SDLa
 * (c) 2002 Marek "March" Szyprowski <marek@amiga.pl>
 * Wersja 1.3 (29.10.2002)
 *
 * Historia:
 * 29.10.2002 - v1.3 - dodanie defaultowego fonta, wkompilowywanego w program
 * 04.05.2002 - v1.2 - dodanie %e w moim vsnprintf
 * 03.05.2002 - v1.1 - dodanie protezy dla MinGW32 (brak vsnprintf w bibliotece)
 * 01.05.2002 - v1.0 - pierwsza dzialajaca wersja
 *
 *
 * Niniejszy fragment kodu jest wolnym oprogramowaniem; moesz go
 * rozprowadza dalej i/lub modyfikowa na warunkach Powszechnej
 * Licencji Publicznej GNU, wydanej przez Fundacj Wolnego
 * Oprogramowania - wedug wersji 2 tej Licencji lub (wedug twojego
 * wyboru) ktrej z pniejszych wersji.
 *
 * Niniejszy program rozpowszechniany jest z nadziej, i bdzie on
 * uyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domylnej
 * gwarancji PRZYDATNOCI HANDLOWEJ albo PRZYDATNOCI DO OKRELONYCH
 * ZASTOSOWA. W celu uzyskania bliszych informacji signij do
 * Powszechnej Licencji Publicznej GNU.
 *
 */

#ifndef _SDL_font_h
#define _SDL_font_h

#include <stdarg.h>

#define SDL_MAXSTRLEN 1024

//#define SDL_DONT_USEDEFAULTFONT /* mona wyczy, jeeli nie jest potrzebny -> kod o 18Kb krtszy */

typedef struct {
	int width;
	int height;
	SDL_Surface *chars;
	} SDL_Font;

SDL_Font *SDL_LoadFont(SDL_Surface *dstdisplay, char *fontfile);
void SDL_FreeFont(SDL_Font *font);
int SDL_DrawChar(SDL_Surface *dest, int x, int y, SDL_Font *font, unsigned char c);
void SDL_PrintF(SDL_Surface *dest, int x, int y, SDL_Font *font, const char *szFormat, ...);
void SDL_vsPrintF(SDL_Surface *dest, int x, int y, SDL_Font *font, const char *szFormat, va_list args);

#endif
