/*
 * 
 * Symulacja Korkw Ulicznych v3.1 (23.12.2002) by Marek "March" Szyprowski <marek@amiga.pl>
 * 
 * (C) 2002 by Druyna Turnieju Modych Fizykw z XIV L.O. im. Stanisawa Staszica w Warszawie
 *
 * ->> http://tmf.staszic.waw.pl <<-
 *
 * Niniejszy program jest wolnym oprogramowaniem; moesz go
 * rozprowadza dalej i/lub modyfikowa na warunkach Powszechnej
 * Licencji Publicznej GNU, wydanej przez Fundacj Wolnego
 * Oprogramowania - wedug wersji 2 tej Licencji lub (wedug twojego
 * wyboru) ktrej z pniejszych wersji.
 *
 * Niniejszy program rozpowszechniany jest z nadziej, i bdzie on
 * uyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domylnej
 * gwarancji PRZYDATNOCI HANDLOWEJ albo PRZYDATNOCI DO OKRELONYCH
 * ZASTOSOWA. W celu uzyskania bliszych informacji signij do
 * Powszechnej Licencji Publicznej GNU.
 *
 */

#define VERSION "v3.1"
#define DATE "23.12.2002"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>  // time() -> randomize()
#include <SDL/SDL.h>
#include "SDL_font.h"
#include "parse_args.h"

#define randomize() srand(time(NULL))
#define urand()	(1.0*rand()/RAND_MAX)

#define TRUE 1
#define FALSE 0

/* 800 x 600 x 8 */

#define SCR_W	800
#define SCR_H	600

#define CELLS_TMRG 120
#define CELLS_LSPC 1
#define CELL_SMAX 25
#define DIAG_BMR 590
#define DIAG_SP 10
#define DIAG_H 320
#define STATS_TMR 30
#define SPACING 20
#define BAR_MRG 2

int cell_size;
int cell_lmrg;
int cell_tmrg;

int diag_ls;
int diag_lmr;
int diag_tmr;
int diag_h;

int bar_len;

SDL_Surface *_scr;
unsigned char *scr;

SDL_Font *courier;

/* kolorki komrek z samochodami;  0 -> brak samochodu; 10 -> biay*/
char kol[]   = {5, 18, 19, 20, 21, 22, 23, 24, 25, 26, 16};
char kol_r[] = {2, 27, 28, 29, 30, 31, 32, 33, 34, 35, 6};
#define SLEDZONY 10
#define SZARY 5


/*
 0..17 szary
 18..26 czerwony..niebieski
 27..35 czerwony..niebieski (ciemny)
 36..45 zolty...zielony
*/

SDL_Color pal[0x30] = {
	 {000, 000, 000},	{ 16, 16, 16},	{ 32, 32, 32}, 	{ 48, 48, 48},	
	 { 64, 64, 64},	{80, 80, 80},	{ 96, 96, 96}, 	{112, 112, 112},
	 {128, 128, 128},	{144, 144, 144}, {160, 160, 160}, {176, 176, 176}, 
	 {192, 192, 192}, {208, 208, 208}, {224, 224, 224}, {240, 240, 240}, 
	 {255, 255, 255},
	 
	 {255, 96, 96 }, {236, 96, 116}, {216, 96, 136}, {196, 96, 156},
	 {176, 96, 176}, {156, 96, 196}, {136, 96, 216}, {116, 96, 236},
	 { 96, 96, 255},
	 
	 {160,  0,  0 }, {140, 0, 20}, {120, 0, 40}, {100, 0, 60}, 
	 {80, 0, 80}, {60, 0, 100}, {40, 0, 120}, {20, 0, 140}, {0, 0, 160},
	  
	 {240, 240, 0},   {216, 240, 10},  {192, 240, 20},   {168, 240, 30}, 
	 {144, 240, 40}, {120, 240, 50}, {96, 240, 60}, {72, 240, 70}, 
	 {48, 240, 80}, {24, 240, 90},
	 
	 {224, 128, 224}, {240, 128, 240}, {255, 128, 255}
};


int speeds[] = {400, 200, 160, 120, 80, 60, 40, 30, 20, 10, 0};

struct kom {
	int sam;
	int v;
	int tmp;
	int vmax;
	};

struct pas_stats {
	int flow;
	int v_sr;
	int nsam;
	int zmpl;
	int zmpp;
	};

struct pas_stats *pstats;

enum State {None, Changed};

char plik[0x8f] = "statystyka.txt";

int sledz = FALSE;
int randomt = 0;
int help = FALSE;
int speed = 4;
int fullscreen = FALSE;
int stats = FALSE;

int nkom = 60;
int nsam = 20;
int nsam1, nsam2 = 0;

int vmax = 5;
int vmax2 = 5;
int np = 2;
int d = 8;

int r = 32;
int t = 64;
int k = 10;

float pp = 0.5;
float pp1, pp2 = 0;

float pkol;

struct kom **pas;
struct kom **tmp;

struct kom *pasy;
struct kom *tmpy;

int *v_data;
int *v_data_all;

void initgr(void)
{
	SDL_Init(SDL_INIT_VIDEO);
	
	if (!(_scr = SDL_SetVideoMode(SCR_W, SCR_H, 8, (fullscreen ? SDL_FULLSCREEN : 0))))
	{
		fprintf(stderr, "can't get SDL surface: %s\n", SDL_GetError());
		exit(1);
	}
	
	scr = (unsigned char *) (_scr->pixels);
	SDL_SetPalette(_scr, SDL_LOGPAL | SDL_PHYSPAL, pal, 0, 48);

	courier = SDL_LoadFont(_scr, NULL);

	SDL_WarpMouse(SCR_W-1, SCR_H-1);

	cell_tmrg = STATS_TMR + (vmax2+3)*courier->height + SPACING;

	cell_size = SCR_W/(nkom+1);
	if (cell_size > CELL_SMAX)
	 	cell_size = CELL_SMAX;
	cell_lmrg = (SCR_W - nkom*cell_size)/2;
		
	diag_tmr = cell_tmrg + np*cell_size + np*CELLS_LSPC + SPACING;
	diag_h = DIAG_BMR - diag_tmr; 
	
	for (diag_ls=1; np*(nkom*diag_ls + DIAG_SP) < SCR_W; diag_ls++)
		;
	--diag_ls;
	if (diag_ls > 3)
		diag_ls = 3;
	
	diag_lmr = (SCR_W - (np*nkom*diag_ls + (np-1)*DIAG_SP)) / 2;

	pkol = 9.0 / np;
	
	bar_len = (nkom*diag_ls - 6*courier->width - 2*BAR_MRG) / (0.8 * nsam / np);
}

void freegr(void)
{
	SDL_FreeFont(courier);
	SDL_Quit();
}

void init(void )
{
	int i;
	
	pasy = malloc(np * nkom * sizeof (struct kom));
	tmpy = malloc(np * nkom * sizeof (struct kom));

	pas = malloc (np * sizeof (struct kom *));
	tmp = malloc (np * sizeof (struct kom *));

	v_data = malloc((vmax2 + 1) * sizeof (int));
	v_data_all = malloc((vmax2 + 1) * sizeof (int));

	pstats = malloc(np * sizeof (struct pas_stats));
	
	for (i=0; i<np; i++)
		pas[i] = pasy + nkom * i;
	
	for (i=0; i<np; i++)
		tmp[i] = tmpy + nkom * i;
}

void setup()
{
	int i, j;

	memset(pasy, 0, np * nkom * sizeof (struct kom));	
	
	i = nsam;
	while (i > 0)
	{
		j = (urand() * nkom*np);
		if (pasy[j].sam == 0)
		{
			if (i == 1)
				pasy[j].sam = SLEDZONY;
			else
				pasy[j].sam = 1;
			pasy[j].vmax = vmax + rand()%(vmax2-vmax+1);
			i--;
		}
	}
}

void free_all (void)
{
	free(pasy);
	free(tmpy);
	free(pas);
	free(tmp);
	free(v_data);
}

void draw_cell (int x, int y, int state)
{
	int i, size=cell_size;
	unsigned char *p, *end;
	
	for (p = scr + x + y*SCR_W, end=p+size; p < end; p++)
		*p = kol_r[state];
	for (p = scr + x + (y+size-1)*SCR_W, end=p+size; p < end; p++)
		*p = kol_r[state];
		
	for (i=1; i < size - 1; i++)
	{
		p = scr + x + (y+i)*SCR_W;
		end = p+size;
		*p++ = kol_r[state];
		while (p < end - 1)
			*p++ = kol[state];
		*p++ = kol_r[state];
	}				
}

void dcells(void)
{
	int i, j;

	for (j=0; j<np; j++)
		for (i=0; i<nkom; i++)
			draw_cell (cell_lmrg+i*cell_size, cell_tmrg+(np-j-1)*(cell_size+CELLS_LSPC), (sledz && pas[j][i].sam == SLEDZONY) ? SLEDZONY : ((pas[j][i].sam > 0) ? j*pkol+1 : 0));
}

void drect(int x, int y, int w, int h, int c)
{
	 SDL_Rect r;
	 r.x = x; r.y = y; r.w = w; r.h = h;
	 SDL_FillRect(_scr, &r, c);
}

void dbar(int x, int y, int height, int len)
{
	int i;
	for (i=0; i<len; i++)
		drect(x+i*bar_len, y, bar_len, height, (i > 8) ? 44 : 35+i);
}

void dstats (void)
{
	 int i, n;

	for (i=0; i<=vmax2; i++)
		v_data_all[i] = 0;

	drect(0, STATS_TMR + courier->height, SCR_W, (vmax2+2)*courier->height, 0);

	 for (n=np-1; n>=0; n--)
	 {
	float v_sr=0;
	int sam=0;
	
	    for (i=0; i<=vmax2; i++)
			v_data[i] = 0;
	
	    for (i=0; i<nkom; i++)
			if (pas[n][i].sam != 0)
				v_data[pas[n][i].v]++;

	    for (i=0; i<=vmax2; i++)
	    {
			v_sr += v_data[i] * i;
			sam += v_data[i];
	    }
	
	    if (sam > 0)
			v_sr = v_sr / sam;
	    else
			v_sr = 0;
	
	    for (i=0; i<=vmax2; i++)
		{
			SDL_PrintF(_scr, diag_lmr+((np-n-1)*nkom)*diag_ls + (np-n-1)*DIAG_SP, STATS_TMR + (i+1) * courier->height, courier, " %d: %d ", i, v_data[i]);
			dbar(diag_lmr+((np-n-1)*nkom)*diag_ls + (np-n-1)*DIAG_SP + 6*courier->width + BAR_MRG, STATS_TMR + (i+1) * courier->height + BAR_MRG, courier->height - 2*BAR_MRG, v_data[i]);
		}	
	    SDL_PrintF(_scr, diag_lmr+((np-n-1)*nkom)*diag_ls + (np-n-1)*DIAG_SP, STATS_TMR + (vmax2+2) * courier->height, courier, "r: %3.1f ", v_sr);
	}
}

void ddiagr(void)
{
	int i, j, jj, n=0;
	int val;
	
	SDL_Rect src, dst;
	
	src.x = diag_lmr-1; src.y = diag_tmr + diag_ls;
	src.w = np*nkom*diag_ls+(np-1)*DIAG_SP+2; src.h = diag_h;
	dst.x = src.x; dst.y = src.y - diag_ls;
	
	SDL_BlitSurface(_scr, &src, _scr, &dst);

	
	for (n=0; n<np; n++)
	{
		for (jj=0; jj<diag_ls; jj++)
		{		
			*(scr + diag_lmr + (DIAG_BMR+jj)*SCR_W + ((np-n-1)*nkom)*diag_ls + (np-n-1)*DIAG_SP - 1) = SZARY;
			*(scr + diag_lmr + (DIAG_BMR+jj)*SCR_W + ((np-n)*nkom)*diag_ls + (np-n-1)*DIAG_SP) = SZARY;
		}
		for (i=0; i<nkom; i++)
		{
			if (pas[n][i].sam == 0)
				val = 0;
			else
				val = 27+n*pkol;
								
			for (j=0; j<diag_ls; j++)
				for (jj=0; jj<diag_ls; jj++)
					*(scr + diag_lmr + (DIAG_BMR+jj)*SCR_W + j + (((np-n-1)*nkom)+i)*diag_ls + (np-n-1)*DIAG_SP) = val;
		}
	}
}

void frame (void)
{
	int i, j, n;
	int v, z;
	
	// zmiana pasw na lewo
	for (n=np-2; n >= 0; n--)
		for (i=0; i<nkom; i++)
			if (pas[n][i].sam != 0 && pas[n][i].v > 0) 
			{
				v = pas[n][i].v;
				j = i;
				// czy warto na lewo
				while (((pas[n][j % nkom].v >= v) || (pas[n][j % nkom].sam == 0)) && (j <= i + d))
					j++;

				if (j < i + d) // tak 
				{
				// czy mona
		   		j = i - pas[n][i].vmax;
			   	while ((pas[n+1][(j + nkom) % nkom].sam == 0) && (j <= i + pas[n][i].v))
						j++;
	
					if (j > i + pas[n][i].v)
					{
						pas[n+1][i] = pas[n][i]; // zmiana pasa
						pas[n+1][i].tmp = Changed;
						pas[n][i].sam = 0;
						pas[n][i].v = 0;
						if (stats) 
							pstats[n].zmpl++;
					}
				}
			}

	// zmiana pasw na prawo
	for (n=1; n < np; n++)
		for (i=0; i<nkom; i++)
			if (pas[n][i].sam != 0 && pas[n][i].v > 0) 
			{
				v = pas[n][i].v;
				z = 0;

				// czy mona
	   		j = i - pas[n][i].vmax;
		   	while ((pas[n-1][(j + nkom) % nkom].sam == 0) && (j <= i + pas[n][i].v))
					j++;
				
				if (j > i + pas[n][i].v && pas[n][i].tmp != Changed)
				{
					// czy trzeba 
					j = i + 1;
					while (((pas[n][j % nkom].v >= v) || (pas[n][j % nkom].sam == 0)) && (j <= i + d))
						j++;
					if (j < i + d)
						z++;

					// czy warto 
					j = i;
					while (((pas[n-1][j % nkom].v >= v) || (pas[n-1][j % nkom].sam == 0)) && (j <= i + d))
						j++;
		    		if (j >= i + d)
						z++;
	
					if (z)
					{
						pas[n-1][i] = pas[n][i]; // zmiana pasa
						pas[n-1][i].tmp = Changed;
						pas[n][i].sam = 0;
						pas[n][i].v = 0;
						if (stats) 
							pstats[n].zmpp++;
					}
				}
			}
			
	for (i=0; i < np*nkom; i++)
		pasy[i].tmp = None;	

	// przyspieszanie
	for (n=0; n<np; n++)
		for (i=0; i<nkom; i++)
			if (pas[n][i].sam != 0 && pas[n][i].v < pas[n][i].vmax)
			{
				for (j=0; j < pas[n][i].v+1 && pas[n][(i+j+1) % nkom].sam == 0; j++)
					;
				if (j == pas[n][i].v+1)
					if (pp > urand())
						pas[n][i].v++;
			}
		
	// hamowanie
	for (n=0; n<np; n++)
		for (i=0; i<nkom; i++)
			if (pas[n][i].sam != 0 && pas[n][i].v > 0)
			{
				for (j=0; j < pas[n][i].v+1 && pas[n][(i+j+1) % nkom].sam == 0; j++) // czy jest po co
					;
				if (j < pas[n][i].v)
				{
					if (pp > urand() || j == 0)
						pas[n][i].v = j;
					else
						pas[n][i].v = j-1;
				}
			}

	memset(tmpy, 0, np*nkom*sizeof(struct kom));

	// ruch waciwy
	for (n=0; n<np; n++)
		for (i=0; i<nkom; i++)
		{
			if (pas[n][i].sam != 0)
			{
				if (stats && i+pas[n][i].v > nkom)
					pstats[n].flow++;
				tmp[n][(i+pas[n][i].v) % nkom] = pas[n][i];
			}
		}

	memcpy(pasy, tmpy, np*nkom*sizeof(struct kom));
}

void calc_stats (void)
{
	int n, i;
	
	for (n=0; n<np; n++)
		for (i=0; i<nkom; i++)
			if (pas[n][i].sam != 0)
			{
				pstats[n].nsam++;
				pstats[n].v_sr += pas[n][i].v;
			}
}

void zero_stats(void)
{
	memset(pstats, 0, np*sizeof(struct pas_stats));
}

struct arg args[] = {
	{SWITCH, 'h', "Wywietla ten pomocniczy tekst", &help},
	{INT, 'p', "Ilo pasw (1 - 8)", &np},
	{INT, 'l', "Ilo komrek na pas", &nkom},
	{INT, 'n', "Pocztkowa ilo samochodw", &nsam},
	{INT, 'N', "Kocowa ilo samochodw", &nsam2},
	{INT, 'v', "Dolna maksymalna prdko", &vmax},
	{INT, 'V', "Grna maksymalna prdko", &vmax2},
	{FLOAT, 'a', "Pocztkowa sprawno kierowcw (0.0 - 1.0)", &pp},
	{FLOAT, 'A', "Kocowa sprawno kierowcw (0.0 - 1.0)", &pp2},
	{INT, 'd', "Pole widzenia kierowcw", &d},
	{SWITCH, 's', "Wczenie trybu \"statystyka\"", &stats},
	{STRING, 'o', "Nazwa pliku do zapisania statystyk", plik},
	{INT, 'r', "Ilo rozbiegowych ramek", &r},
	{INT, 't', "Ilo ramek do zliczenia statystyki", &t},
	{INT, 'k', "Ilo krokw przy zmianie parametrw", &k},
	{INT, 'f', "Prdko symulacji graficznej (0 - 10)", &speed},
	{SWITCH, 'F', "Uruchomienie programu w trybie penoekranowym", &fullscreen},
	{SWITCH, 'x', "Wczenie ledzenia samochodu", &sledz},
	{INT, 'y', "Ziarno dla generatora liczb losowych", &randomt},
	{END, 0, NULL, NULL}
	};

void generate_stats(void)
{
	int i, j, n;
	FILE *zapis;
	nsam1 = nsam;
	pp1 = pp;

	if ((zapis = fopen(plik, "w")) == NULL)
	{
		printf("Bd zapisu do pliku!\n");
		return;
	}

	if (nsam2 == 0)
	    nsam2 = nsam;
	if (pp2 == 0)
	    pp2 = pp;

	fprintf(zapis, "gestosc\tsprawn\t");
	for (n=0; n<np; n++)
		fprintf(zapis, "przep%d\tVsred%d\tzm_l%d\tzm_p%d\t", n+1, n+1, n+1, n+1);
	fprintf(zapis, "\n");

	for (i=0; i<k; i++)
	{
		nsam = nsam1 + (nsam2-nsam1)*i/(k-1);
		pp = pp1 + (pp2-pp1)*i/(k-1);
		
		fprintf(zapis, "%.5f\t%.3f\t", 1.0*nsam/(nkom*np), pp);
		setup();
		for (j=0; j<r; j++)
			frame();
		zero_stats();
		for (j=0; j<t; j++)
		{
			frame();
			calc_stats();
		}
		for (n=0; n<np; n++)
			fprintf(zapis, "%.5f\t%.5f\t%.5f\t%.5f\t", (1.0*pstats[n].flow)/t, (pstats[n].nsam != 0) ? (1.0*pstats[n].v_sr)/(pstats[n].nsam) : 0, (1.0*pstats[n].zmpl)/t, (1.0*pstats[n].zmpp)/t);
		fprintf(zapis, "\n");
	}
	fclose(zapis);
}

void gfx_simulation()
{
	int n, q = FALSE, manual = FALSE, draw = TRUE;
	SDL_Event ev;

	initgr();
	setup();
		
	SDL_PrintF(_scr, 2, 4, courier, "-: Symulacja korkw ulicznych " VERSION " :-    (C) 2002 Druyna TMF z XIV LO im. St. Staszica w Warszawie");

	for (n=0; n<np; n++)
		SDL_PrintF(_scr, diag_lmr+((np-n-1)*nkom)*diag_ls + (np-n-1)*DIAG_SP, STATS_TMR, courier, " V  n ");	

	while (!q) 
	{
		if (draw)
		{
			dcells();
			ddiagr();
			dstats();
			SDL_UpdateRect(_scr, 0, 0, 0, 0);
			frame();
		}
		
		draw = FALSE;
	
		if (!manual)
			draw = TRUE;
		
	    while (SDL_PollEvent(&ev))
			if (ev.type == SDL_KEYDOWN)
				switch (ev.key.keysym.sym)
				{
					case SDLK_q:
					case SDLK_ESCAPE:
						q++;
						break;
					case SDLK_EQUALS:
					case SDLK_PLUS:
						if (manual)
							manual = FALSE;
						else if (speed < 10)
							speed++;
						break;
					case SDLK_MINUS:
						if (speed > 0)
							speed--;
						else
							manual = TRUE;
						break;
					case SDLK_SPACE:
						draw=TRUE;
						break;
					case SDLK_m:
						if (manual)
							manual = FALSE;
						else
							manual = TRUE;
							speed = 8;
						break;
					default:
						break;
				}
				
		SDL_Delay(speeds[speed]);
	}
	freegr();
}

int main(int argc, char *argv[])
{
	parse_args(args, argc, argv);

	if (help)
	{
		printf("Symulacja korkw ulicznych " VERSION " (" DATE ")\n(c) 2002 Druyna TMF z XIV LO im. St. Staszica w Warszawie\nAutor: Marek \"March\" Szyprowski <march@staszic.waw.pl>\nProgram rozpowszechniany jest na zasadach Powszechnej Licencji Publicznej GNU.\nWicej infomacji znale mona w dokumentacji.\n\nDostpne opcje:\n");
		print_help(args);
		return 0;
	}

	if (randomt == 0)
		randomize();
	else
		srand(randomt);

	init();
	
	if (stats)
		generate_stats();
	else
		gfx_simulation();

	free_all();
	return 0;
}
