/*
 *	Uatwienie obsugi argumentw
 *
 * (c) 2002 Marek Szyprowski <march@staszic.waw.pl>
 *
 * Niniejszy fragment kodu jest wolnym oprogramowaniem; moesz go
 * rozprowadza dalej i/lub modyfikowa na warunkach Powszechnej
 * Licencji Publicznej GNU, wydanej przez Fundacj Wolnego
 * Oprogramowania - wedug wersji 2 tej Licencji lub (wedug twojego
 * wyboru) ktrej z pniejszych wersji.
 *
 * Niniejszy program rozpowszechniany jest z nadziej, i bdzie on
 * uyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domylnej
 * gwarancji PRZYDATNOCI HANDLOWEJ albo PRZYDATNOCI DO OKRELONYCH
 * ZASTOSOWA. W celu uzyskania bliszych informacji signij do
 * Powszechnej Licencji Publicznej GNU.
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "parse_args.h"

void parse_args(struct arg args[], int argc, char *argv[])
{
	int i;
	int need_var = FALSE;
	
	struct arg *ap = args;

	for (i=1; i<argc; i++)	
	{
		if (need_var)
		{
			need_var = FALSE;
			switch (ap->type)
			{
				case INT:
					*((int *)ap->var) = atoi(argv[i]);
					break;
				case FLOAT:
					*((float *)ap->var) = atof(argv[i]);
					break;
				case STRING:
					strcpy(ap->var, argv[i]);
					break;
			}
		}

		ap = args;

		if (argv[i][0] == '-')
			while (ap->type != END)
			{
				if (ap->letter == argv[i][1])
				{
					need_var = TRUE;
					if (ap->type == SWITCH)
					{
						need_var = FALSE;
						*((int *)ap->var) ^= 1;
					}
					else if (argv[i][2] != '\0')
					{
						need_var = FALSE;
						switch (ap->type)
						{
							case INT:
								*((int *)ap->var) = atoi(argv[i] + 2);
								break;
							case FLOAT:
								*((float *)ap->var) = atof(argv[i] + 2);
								break;
							case STRING:
								strcpy(ap->var, argv[i]+2);
								break;
						}
					}
					break;
				}
				ap++;
			}
	}
}

void print_help (struct arg args[])
{
	struct arg *ap = args;
	
	while (ap->type != END)
	{
		printf("\t-%c %s - %s", ap->letter, (ap->type == INT || ap->type == FLOAT || ap->type == STRING) ? "x" : " ", ap->help);
		switch (ap->type)
		{
			case SWITCH:
				printf("\n");
				break;
			case INT:
				printf(" [%d]\n", *((int *)ap->var));
				break;
			case FLOAT:
				printf(" [%f]\n", *((float *)ap->var));
				break;
			case STRING:
				printf(" [\"%s\"]\n", (char *)ap->var);
				break;
		}
		ap++;
	}
}
